diff -r ec894ddf18f6 trytond/modules/calendar/calendar_.py
--- a/trytond/modules/calendar/calendar_.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/calendar_.py	Mon Sep 24 20:36:40 2012 +0200
@@ -13,6 +13,12 @@
 from trytond.transaction import Transaction
 from trytond.cache import Cache
 from trytond.pool import Pool
+
+__all__ = ['Calendar', 'ReadUser', 'WriteUser', 'Category', 'Location',
+    'Event', 'EventCategory', 'Alarm', 'EventAlarm', 'Attendee',
+    'EventAttendee', 'Date', 'EventRDate', 'EventExDate', 'RRule',
+    'EventRRule', 'EventExRule']
+
 tzlocal = dateutil.tz.tzlocal()
 tzutc = dateutil.tz.tzutc()
 domimpl = xml.dom.minidom.getDOMImplementation()
@@ -20,9 +26,7 @@
 
 class Calendar(ModelSQL, ModelView):
     "Calendar"
-    _description = __doc__
-    _name = 'calendar.calendar'
-
+    __name__ = 'calendar.calendar'
     name = fields.Char('Name', required=True, select=True)
     description = fields.Text('Description')
     owner = fields.Many2One('res.user', 'Owner', select=True,
@@ -32,95 +36,96 @@
             'calendar', 'user', 'Read Users')
     write_users = fields.Many2Many('calendar.calendar-write-res.user',
             'calendar', 'user', 'Write Users')
+    _get_name_cache = Cache('calendar_calendar.get_name')
 
-    def __init__(self):
-        super(Calendar, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(Calendar, cls).__setup__()
+        cls._sql_constraints = [
             ('name_uniq', 'UNIQUE(name)',
                 'The name of calendar must be unique!'),
             ('owner_uniq', 'UNIQUE(owner)',
                 'A user can have only one calendar!'),
-        ]
-        self._order.insert(0, ('name', 'ASC'))
-        self._constraints += [
+            ]
+        cls._order.insert(0, ('name', 'ASC'))
+        cls._constraints += [
             ('check_name', 'Calendar name can not end with .ics'),
-        ]
+            ]
 
-    def create(self, vals):
-        res = super(Calendar, self).create(vals)
+    @classmethod
+    def create(cls, vals):
+        calendar = super(Calendar, cls).create(vals)
         # Restart the cache for get_name
-        self.get_name.reset()
-        return res
+        cls._get_name_cache.reset()
+        return calendar
 
-    def write(self, ids, vals):
-        res = super(Calendar, self).write(ids, vals)
+    @classmethod
+    def write(cls, calendars, vals):
+        super(Calendar, cls).write(calendars, vals)
         # Restart the cache for get_name
-        self.get_name.reset()
-        return res
+        cls._get_name_cache.reset()
 
-    def delete(self, ids):
-        res = super(Calendar, self).delete(ids)
+    @classmethod
+    def delete(cls, calendars):
+        super(Calendar, cls).delete(calendars)
         # Restart the cache for calendar
-        self.get_name.reset()
-        return res
+        cls._get_name_cache.reset()
 
-    def check_name(self, ids):
+    def check_name(self):
         '''
         Check the name doesn't end with .ics
         '''
-        for calendar in self.browse(ids):
-            if calendar.name.endswith('.ics'):
-                return False
+        if self.name.endswith('.ics'):
+            return False
         return True
 
-    @Cache('calendar_calendar.get_name')
-    def get_name(self, name):
+    @classmethod
+    def get_name(cls, name):
         '''
         Return the calendar id of the name
+        '''
+        calendar_id = cls._get_name_cache.get(name, default=-1)
+        if calendar_id == -1:
+            calendars = cls.search([
+                ('name', '=', name),
+                ], limit=1)
+            if calendars:
+                calendar_id = calendars[0].id
+            else:
+                calendar_id = None
+            cls._get_name_cache.set(name, calendar_id)
+        return calendar_id
 
-        :param name: the calendar name
-        :return: the calendar.calendar id
-        '''
-        calendar_ids = self.search([
-            ('name', '=', name),
-            ], limit=1)
-        if calendar_ids:
-            return calendar_ids[0]
-
-    def calendar2ical(self, calendar_id):
+    @staticmethod
+    def calendar2ical(calendar_id):
         '''
         Return an iCalendar object for the given calendar_id containing
         all the vevent objects
-
-        :param calendar_id: an id of calendar.calendar
-        :return: an iCalendar
         '''
-        event_obj = Pool().get('calendar.event')
+        Event = Pool().get('calendar.event')
 
         ical = vobject.iCalendar()
         ical.vevent_list = []
-        event_ids = event_obj.search([
-            ('calendar', '=', calendar_id),
-            ('parent', '=', None),
-            ])
-        for event in event_obj.browse(event_ids):
-            ical2 = event_obj.event2ical(event.id)
+        events = Event.search([
+                ('calendar', '=', calendar_id),
+                ('parent', '=', None),
+                ])
+        for event in events:
+            ical2 = event.event2ical()
             ical.vevent_list.extend(ical2.vevent_list)
         return ical
 
-    def _fbtype(self, event):
+    @property
+    def _fbtype(self):
         '''
         Return the freebusy type for give transparent and status
-
-        :param event: a BrowseRecord of calendar.event
-        :return: a freebusy type ('FREE', 'BUSY', 'BUSY-TENTATIVE')
         '''
-        if event.transp == 'opaque':
-            if not event.status or event.status == 'confirmed':
+        if self.transp == 'opaque':
+            if not self.status or self.status == 'confirmed':
                 fbtype = 'BUSY'
-            elif event.status == 'cancelled':
+            elif self.status == 'cancelled':
                 fbtype = 'FREE'
-            elif event.status == 'tentative':
+            elif self.status == 'tentative':
                 fbtype = 'BUSY-TENTATIVE'
             else:
                 fbtype = 'BUSY'
@@ -128,17 +133,13 @@
             fbtype = 'FREE'
         return fbtype
 
-    def freebusy(self, calendar_id, dtstart, dtend):
+    @classmethod
+    def freebusy(cls, calendar_id, dtstart, dtend):
         '''
         Return an iCalendar object for the given calendar_id with the
         vfreebusy objects between the two dates
-
-        :param calendar_id: an id of calendar.calendar
-        :param dtstart: a date or datetime
-        :param dtend: a date of datetime
-        :return: an iCalendar
         '''
-        event_obj = Pool().get('calendar.event')
+        Event = Pool().get('calendar.event')
 
         ical = vobject.iCalendar()
         ical.add('method').value = 'REPLY'
@@ -157,31 +158,30 @@
             ical.vfreebusy.add('dtend').value = dtend.astimezone(tzutc)
 
         with Transaction().set_user(0):
-            event_ids = event_obj.search([
-                ['OR',
-                    [('dtstart', '<=', dtstart),
-                        ('dtend', '>=', dtstart)],
-                    [('dtstart', '<=', dtend),
-                        ('dtend', '>=', dtend)],
-                    [('dtstart', '>=', dtstart),
-                        ('dtend', '<=', dtend)],
-                    [('dtstart', '>=', dtstart),
-                        ('dtstart', '<=', dtend),
-                        ('dtend', '=', None)]],
-                ('parent', '=', None),
-                ('rdates', '=', None),
-                ('rrules', '=', None),
-                ('exdates', '=', None),
-                ('exrules', '=', None),
-                ('occurences', '=', None),
-                ('calendar', '=', calendar_id),
-                ])
-            events = event_obj.browse(event_ids)
+            events = Event.search([
+                    ['OR',
+                        [('dtstart', '<=', dtstart),
+                            ('dtend', '>=', dtstart)],
+                        [('dtstart', '<=', dtend),
+                            ('dtend', '>=', dtend)],
+                        [('dtstart', '>=', dtstart),
+                            ('dtend', '<=', dtend)],
+                        [('dtstart', '>=', dtstart),
+                            ('dtstart', '<=', dtend),
+                            ('dtend', '=', None)]],
+                    ('parent', '=', None),
+                    ('rdates', '=', None),
+                    ('rrules', '=', None),
+                    ('exdates', '=', None),
+                    ('exrules', '=', None),
+                    ('occurences', '=', None),
+                    ('calendar', '=', calendar_id),
+                    ])
 
         for event in events:
             # Don't group freebusy as sunbird doesn't handle it
             freebusy = ical.vfreebusy.add('freebusy')
-            freebusy.fbtype_param = self._fbtype(event)
+            freebusy.fbtype_param = event._fbtype
             if event.dtstart.replace(tzinfo=tzlocal) >= dtstart:
                 freebusy_dtstart = event.dtstart.replace(tzinfo=tzlocal)
             else:
@@ -195,22 +195,21 @@
                 freebusy_dtend.astimezone(tzutc))]
 
         with Transaction().set_user(0):
-            event_ids = event_obj.search([
-                ('parent', '=', None),
-                ('dtstart', '<=', dtend),
-                ['OR',
-                    ('rdates', '!=', None),
-                    ('rrules', '!=', None),
-                    ('exdates', '!=', None),
-                    ('exrules', '!=', None),
-                    ('occurences', '!=', None),
-                ],
-                ('calendar', '=', calendar_id),
-                ])
-            events = event_obj.browse(event_ids)
+            events = Event.search([
+                    ('parent', '=', None),
+                    ('dtstart', '<=', dtend),
+                    ['OR',
+                        ('rdates', '!=', None),
+                        ('rrules', '!=', None),
+                        ('exdates', '!=', None),
+                        ('exrules', '!=', None),
+                        ('occurences', '!=', None),
+                        ],
+                    ('calendar', '=', calendar_id),
+                    ])
 
         for event in events:
-            event_ical = event_obj.event2ical(event)
+            event_ical = event.event2ical()
             if event_ical.vevent.rruleset:
                 between_dtstart, between_dtend = dtstart, dtend
                 for freebusy_dtstart in event_ical.vevent.rruleset:
@@ -231,7 +230,7 @@
                             or (f_dtstart_tz >= dtstart
                                 and f_dtend_tz <= dtend)):
                         continue
-                    freebusy_fbtype = self._fbtype(event)
+                    freebusy_fbtype = event._fbtype
                     all_day = event.all_day
                     for occurence in event.occurences:
                         if (occurence.recurrence.replace(tzinfo=tzlocal)
@@ -244,7 +243,7 @@
                             else:
                                 freebusy_dtend = freebusy_dtstart
                             all_day = occurence.all_day
-                            freebusy_fbtype = self._fbtype(occurence)
+                            freebusy_fbtype = occurence._fbtype
                             break
                     freebusy = ical.vfreebusy.add('freebusy')
                     freebusy.fbtype_param = freebusy_fbtype
@@ -263,21 +262,19 @@
                             freebusy_dtend.astimezone(tzutc))]
         return ical
 
-    def post(self, uri, data):
+    @classmethod
+    def post(cls, uri, data):
         '''
-        Handle post of vfreebusy request
-
-        :param uri: the posted uri
-        :param data: the posted data
-        :return: the xml with schedule-response
+        Handle post of vfreebusy request and return the XML with
+        schedule-response
         '''
         from pywebdav.lib.errors import DAV_Forbidden
-        collection_obj = Pool().get('webdav.collection')
+        Collection = Pool().get('webdav.collection')
 
-        calendar_id = collection_obj.calendar(uri)
+        calendar_id = Collection.calendar(uri)
         if not calendar_id:
             raise DAV_Forbidden
-        calendar = self.browse(calendar_id)
+        calendar = cls(calendar_id)
         if calendar.owner.id != Transaction().user:
             raise DAV_Forbidden
         ical = vobject.readOne(data)
@@ -318,11 +315,11 @@
                 if attendee.value.lower().startswith('mailto:'):
                     email = attendee.value[7:]
                 with Transaction().set_user(0):
-                    calendar_ids = self.search([
-                        ('owner.email', '=', email),
-                        ])
-                if calendar_ids:
-                    vfreebusy = self.freebusy(calendar_ids[0], dtstart, dtend)
+                    calendars = cls.search([
+                            ('owner.email', '=', email),
+                            ])
+                if calendars:
+                    vfreebusy = cls.freebusy(calendars[0].id, dtstart, dtend)
                     vfreebusy.vfreebusy.add('dtstamp').value = \
                             ical.vfreebusy.dtstamp.value
                     vfreebusy.vfreebusy.add('uid').value = \
@@ -343,77 +340,59 @@
             return doc.toxml(encoding='utf-8')
         raise DAV_Forbidden
 
-Calendar()
-
 
 class ReadUser(ModelSQL):
     'Calendar - read - User'
-    _description = __doc__
-    _name = 'calendar.calendar-read-res.user'
-
+    __name__ = 'calendar.calendar-read-res.user'
     calendar = fields.Many2One('calendar.calendar', 'Calendar',
             ondelete='CASCADE', required=True, select=True)
     user = fields.Many2One('res.user', 'User', ondelete='CASCADE',
             required=True, select=True)
 
-ReadUser()
-
 
 class WriteUser(ModelSQL):
     'Calendar - write - User'
-    _description = __doc__
-    _name = 'calendar.calendar-write-res.user'
-
+    __name__ = 'calendar.calendar-write-res.user'
     calendar = fields.Many2One('calendar.calendar', 'Calendar',
             ondelete='CASCADE', required=True, select=True)
     user = fields.Many2One('res.user', 'User', ondelete='CASCADE',
             required=True, select=True)
 
-WriteUser()
-
 
 class Category(ModelSQL, ModelView):
     "Category"
-    _description = __doc__
-    _name = 'calendar.category'
-
+    __name__ = 'calendar.category'
     name = fields.Char('Name', required=True, select=True)
 
-    def __init__(self):
-        super(Category, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(Category, cls).__setup__()
+        cls._sql_constraints = [
             ('name_uniq', 'UNIQUE(name)',
                 'The name of calendar category must be unique!'),
-        ]
-        self._order.insert(0, ('name', 'ASC'))
-
-Category()
+            ]
+        cls._order.insert(0, ('name', 'ASC'))
 
 
 class Location(ModelSQL, ModelView):
     "Location"
-    _description = __doc__
-    _name = 'calendar.location'
-
+    __name__ = 'calendar.location'
     name = fields.Char('Name', required=True, select=True)
 
-    def __init__(self):
-        super(Location, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(Location, cls).__setup__()
+        cls._sql_constraints = [
             ('name_uniq', 'UNIQUE(name)',
                 'The name of calendar location must be unique!'),
-        ]
-        self._order.insert(0, ('name', 'ASC'))
-
-Location()
+            ]
+        cls._order.insert(0, ('name', 'ASC'))
 
 
 class Event(ModelSQL, ModelView):
     "Event"
-    _description = __doc__
-    _name = 'calendar.event'
+    __name__ = 'calendar.event'
     _rec_name = 'uuid'
-
     uuid = fields.Char('UUID', required=True,
             help='Universally Unique Identifier', select=True)
     calendar = fields.Many2One('calendar.calendar', 'Calendar',
@@ -496,90 +475,95 @@
         'Write Users'), 'get_calendar_field', searcher='search_calendar_field')
     vevent = fields.Binary('vevent')
 
-    def __init__(self):
-        super(Event, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(Event, cls).__setup__()
+        cls._sql_constraints = [
             ('uuid_recurrence_uniq', 'UNIQUE(uuid, calendar, recurrence)',
                 'UUID and recurrence must be unique in a calendar!'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_recurrence', 'invalid_recurrence'),
-        ]
-        self._error_messages.update({
-            'invalid_recurrence': 'Recurrence can not be recurrent!',
-        })
+            ]
+        cls._error_messages.update({
+                'invalid_recurrence': 'Recurrence can not be recurrent!',
+                })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         # Migrate from 1.4: remove classification_public
-        model_data_obj = Pool().get('ir.model.data')
-        rule_obj = Pool().get('ir.rule')
+        ModelData = Pool().get('ir.model.data')
+        Rule = Pool().get('ir.rule')
         with Transaction().set_user(0):
-            model_data_ids = model_data_obj.search([
-                ('fs_id', '=', 'rule_group_read_calendar_line3'),
-                ('module', '=', module_name),
-                ('inherit', '=', None),
-                ], limit=1)
-            if model_data_ids:
-                model_data = model_data_obj.browse(model_data_ids[0])
-                rule_obj.delete(model_data.db_id)
-        return super(Event, self).init(module_name)
+            models_data = ModelData.search([
+                    ('fs_id', '=', 'rule_group_read_calendar_line3'),
+                    ('module', '=', module_name),
+                    ('inherit', '=', None),
+                    ], limit=1)
+            if models_data:
+                model_data, = models_data
+                Rule.delete([Rule(model_data.db_id)])
+        return super(Event, cls).__register__(module_name)
 
-    def default_uuid(self):
+    @staticmethod
+    def default_uuid():
         return str(uuid.uuid4())
 
-    def default_sequence(self):
+    @staticmethod
+    def default_sequence():
         return 0
 
-    def default_classification(self):
+    @staticmethod
+    def default_classification():
         return 'public'
 
-    def default_transp(self):
+    @staticmethod
+    def default_transp():
         return 'opaque'
 
-    def default_timezone(self):
-        user_obj = Pool().get('res.user')
-        user = user_obj.browse(Transaction().user)
+    @staticmethod
+    def default_timezone():
+        User = Pool().get('res.user')
+        user = User(Transaction().user)
         return user.timezone
 
-    def timezones(self):
+    @staticmethod
+    def timezones():
         return [(x, x) for x in pytz.common_timezones] + [('', '')]
 
-    def get_calendar_field(self, ids, name):
+    def get_calendar_field(self, name):
         assert name in ('calendar_owner', 'calendar_read_users',
                 'calendar_write_users'), 'Invalid name'
-        res = {}
         name = name[9:]
-        for event in self.browse(ids):
-            if name in ('read_users', 'write_users'):
-                res[event.id] = [x.id for x in event.calendar[name]]
-            else:
-                res[event.id] = event.calendar[name].id
-        return res
+        if name in ('read_users', 'write_users'):
+            return [x.id for x in getattr(self.calendar, name)]
+        else:
+            return getattr(self.calendar, name).id
 
-    def search_calendar_field(self, name, clause):
+    @classmethod
+    def search_calendar_field(cls, name, clause):
         return [('calendar.' + name[9:],) + clause[1:]]
 
-    def check_recurrence(self, ids):
+    def check_recurrence(self):
         '''
         Check the recurrence is not recurrent.
         '''
-        for event in self.browse(ids):
-            if not event.parent:
-                continue
-            if event.rdates \
-                    or event.rrules \
-                    or event.exdates \
-                    or event.exrules \
-                    or event.occurences:
+        if self.parent:
+            if self.rdates \
+                    or self.rrules \
+                    or self.exdates \
+                    or self.exrules \
+                    or self.occurences:
                 return False
         return True
 
-    def create(self, values):
-        calendar_obj = Pool().get('calendar.calendar')
-        collection_obj = Pool().get('webdav.collection')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Calendar = pool.get('calendar.calendar')
+        Collection = pool.get('webdav.collection')
 
-        res = super(Event, self).create(values)
-        event = self.browse(res)
+        event = super(Event, cls).create(values)
         if (event.calendar.owner
                 and (event.organizer == event.calendar.owner.email
                     or (event.parent
@@ -595,94 +579,80 @@
                         and x.email != event.parent.organizer]
             if attendee_emails:
                 with Transaction().set_user(0):
-                    calendar_ids = calendar_obj.search([
-                        ('owner.email', 'in', attendee_emails),
-                        ])
+                    calendars = Calendar.search([
+                            ('owner.email', 'in', attendee_emails),
+                            ])
                     if not event.recurrence:
-                        for calendar_id in calendar_ids:
-                            new_id = self.copy(event.id, default={
-                                'calendar': calendar_id,
-                                'occurences': None,
-                                })
+                        for calendar in calendars:
+                            new_event, = cls.copy([event], default={
+                                    'calendar': calendar.id,
+                                    'occurences': None,
+                                    })
                             for occurence in event.occurences:
-                                self.copy(occurence.id, default={
-                                    'calendar': calendar_id,
-                                    'parent': new_id,
+                                cls.copy([occurence], default={
+                                    'calendar': calendar.id,
+                                    'parent': new_event.id,
                                     })
                     else:
-                        parent_ids = self.search([
-                            ('uuid', '=', event.uuid),
-                            ('calendar.owner.email', 'in', attendee_emails),
-                            ('id', '!=', event.id),
-                            ('recurrence', '=', None),
-                            ])
-                        for parent in self.browse(parent_ids):
-                            self.copy(event.id, default={
-                                'calendar': parent.calendar.id,
-                                'parent': parent.id,
-                                })
+                        parents = cls.search([
+                                ('uuid', '=', event.uuid),
+                                ('calendar.owner.email', 'in',
+                                    attendee_emails),
+                                ('id', '!=', event.id),
+                                ('recurrence', '=', None),
+                                ])
+                        for parent in parents:
+                            cls.copy([event], default={
+                                    'calendar': parent.calendar.id,
+                                    'parent': parent.id,
+                                    })
         # Restart the cache for event
-        collection_obj.event.reset()
-        return res
+        Collection._event_cache.reset()
+        return event
 
-    def _event2update(self, event):
+    def _event2update(self):
+        return {
+            'summary': self.summary,
+            'description': self.description,
+            'all_day': self.all_day,
+            'dtstart': self.dtstart,
+            'dtend': self.dtend,
+            'location': self.location.id,
+            'status': self.status,
+            'organizer': self.organizer,
+            'rdates': [('delete_all',)] + [('create', rdate._date2update())
+                for rdate in self.rdates],
+            'exdates': [('delete_all',)] + [('create', exdate._date2update())
+                for exdate in self.exdates],
+            'rrules': [('delete_all',)] + [('create', rrule._date2update())
+                for rrule in self.rrules],
+            'exrules': [('delete_all',)] + [('create', exrule._date2update())
+                for exrule in self.exrules],
+            }
+
+    @classmethod
+    def write(cls, events, values):
         pool = Pool()
-        rdate_obj = pool.get('calendar.event.rdate')
-        exdate_obj = pool.get('calendar.event.exdate')
-        rrule_obj = pool.get('calendar.event.rrule')
-        exrule_obj = pool.get('calendar.event.exrule')
-
-        res = {}
-        res['summary'] = event.summary
-        res['description'] = event.description
-        res['all_day'] = event.all_day
-        res['dtstart'] = event.dtstart
-        res['dtend'] = event.dtend
-        res['location'] = event.location.id
-        res['status'] = event.status
-        res['organizer'] = event.organizer
-        res['rdates'] = [('delete_all',)]
-        for rdate in event.rdates:
-            vals = rdate_obj._date2update(rdate)
-            res['rdates'].append(('create', vals))
-        res['exdates'] = [('delete_all',)]
-        for exdate in event.exdates:
-            vals = exdate_obj._date2update(exdate)
-            res['exdates'].append(('create', vals))
-        res['rrules'] = [('delete_all',)]
-        for rrule in event.rrules:
-            vals = rrule_obj._rule2update(rrule)
-            res['rrules'].append(('create', vals))
-        res['exrules'] = [('delete_all',)]
-        for exrule in event.exrules:
-            vals = exrule_obj._rule2update(exrule)
-            res['exrules'].append(('create', vals))
-        return res
-
-    def write(self, ids, values):
-        calendar_obj = Pool().get('calendar.calendar')
-        collection_obj = Pool().get('webdav.collection')
+        Calendar = pool.get('calendar.calendar')
+        Collection = pool.get('webdav.collection')
         cursor = Transaction().cursor
 
         values = values.copy()
         if 'sequence' in values:
             del values['sequence']
 
-        res = super(Event, self).write(ids, values)
+        super(Event, cls).write(events, values)
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        for i in range(0, len(ids), cursor.IN_MAX):
-            sub_ids = ids[i:i + cursor.IN_MAX]
+        for i in range(0, len(events), cursor.IN_MAX):
+            sub_ids = map(int, events[i:i + cursor.IN_MAX])
             red_sql, red_ids = reduce_ids('id', sub_ids)
-            cursor.execute('UPDATE "' + self._table + '" ' \
-                    'SET sequence = sequence + 1 ' \
-                    'WHERE ' + red_sql, red_ids)
+            cursor.execute('UPDATE "' + cls._table + '" '
+                'SET sequence = sequence + 1 '
+                'WHERE ' + red_sql, red_ids)
 
         if not values:
-            return res
-        for event in self.browse(ids):
+            return
+        for event in events:
             if event.calendar.owner \
                     and (event.organizer == event.calendar.owner.email \
                     or (event.parent \
